#!/usr/bin/env python
import inspect
from isobject import *
from public import *

@public
def isattribute(cls,attr):
    if attr is None: return None
    if isobject(attr):
        for name,object in inspect.getmembers(cls):
            if object==attr:
                return True
        return False
    if hasattr(attr,"__name__"):
        name = attr.__name__
    else:
        if not hasattr(cls,attr): return False
        name = attr
    object = getattr(cls,name)
    return not isinstance(object,property) and not inspect.isroutine(object)

if __name__=="__main__":
    class CLS:
        attr = "value"
        @property
        def property(self): pass
    print(isattribute(CLS,"attr")) # True
    print(isattribute(CLS,"property")) # False
    print(isattribute(CLS,"not-existing-attr")) # False
    print(isattribute(CLS,None)) # None
